<template>
    <div class="worker-list">
        <div class="error">{{error}}</div>
        <div class="message">{{message}}</div>
        <label>Worker Name </label><input v-model="worker"/><br>
        <label>Tag Mac Address </label><input v-model="mac"/>
        <label>Endpoint </label><input style="width:300px" v-model="endpoint"/><br>
        <button @click="submit">Create</button>
        <br>
        <button @click="save">Save</button>
        <button @click="load">Load</button>

        <label>Refresh Delay </label><input v-model="timeout"/><br>
        <label>Floorplan image </label><input v-model="src"/>
        <button @click="clear">Clear</button>
        <label>Pull Data</label><input type="checkbox" v-model="ans">
        <br>
        <div class="parent">
            <div class="id">Id</div>
            <div class="name">Worker Name</div>
            <div class="x">X</div>
            <div class="y">Y</div>
        </div>
        <div class="parent" v-for="(item, _) in allWorkers">
            <div class="id">{{item.id}}</div>
            <div class="name">{{item.name}}</div>
            <div class="x">{{item.x}}</div>
            <div class="y">{{item.y}}</div>
        </div>
        <br>
        <label>Width </label><input v-model="width"/>
        <label>Height</label><input v-model="height"/>
        <label>End X</label><input v-model="X"/>
        <label>End Y</label><input v-model="Y"/>
        <br>
        <div class="floorplan" :style="Style">
            <img class='max' :src="src">
            <div class="parent" v-for="(item, _) in allWorkers">
                <div class="dot" :style="{
                    left: (item.x/X)*100 + '%',
                    top: (item.y/Y)*100 + '%',
                }">
                    <div class="label">
                        {{item.name}}
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<style lang='scss' scoped>
    .error {
        font-family: "Roboto Light", sans-serif;
        color: red;
    }

    .worker-list {
        font-family: "Roboto Light", sans-serif;

        .dot {
            position: absolute;
            width: 10px;
            height: 10px;
            background: blue;
            border-radius: 50%;
            transform: translate(-50%, -50%);
            transition: left 1s, top 1s;

            .label {
                font-size: 12px;
                font-family: "Roboto Light", sans-serif;
                transform: translate(-50%, -100%);
            }
        }


        .max {
            position: absolute;
            width: 100%;
            height: 100%;
        }

        .floorplan {
            position: relative;
            border: 3px dashed black;
            background: white;
        }

        .parent {
            display: flex;
            text-align: center;
        }

        .id {
            border: 1px solid black;
            width: 400px;
        }

        .name {
            border: 1px solid black;
            width: 200px;
        }

        .x, .y {
            border: 1px solid black;
            width: 40px;
        }
    }
</style>

<script lang='ts'>
    import {Component, Vue} from 'vue-property-decorator';
    import {HttpClient} from "../../../classLibrary/Client";
    import {FullWorker, IWorker} from "../../../classLibrary/Worker";


    @Component({})
    export default class WorkerList extends Vue {
        http: HttpClient = new HttpClient();
        allWorkers: { [s: string]: FullWorker } = {};
        timeout: number = 5000;
        ptimeout: number = 5000;
        width: number = 10;
        height: number = 10;
        X: number = 10;
        Y: number = 10;
        src: string = '';
        ans: boolean = true;
        worker: string = "";
        mac: string = "";
        error: string = "";
        message: string = "";
        endpoint: string = "https://dev.api.buildify.atomi.cloud";

        save() {
            const data = {
                timeout: this.timeout,
                ptimeout: this.ptimeout,
                width: this.width,
                height: this.height,
                X: this.X,
                Y: this.Y,
                src: this.src,
                ans: this.ans,
                endpoint: this.endpoint,
            };
            const s = JSON.stringify(data);
            localStorage.setItem("DATA", s);
        }

        load() {
            const s = localStorage.getItem("DATA");
            if (s != null) {
                const data = JSON.parse(s);
                this.src = data.src;
                this.timeout = data.timeout;
                this.ptimeout = data.ptimeout;
                this.width = data.width;
                this.height = data.height;
                this.X = data.X;
                this.Y = data.Y;
                this.ans = data.ans;
                this.endpoint = data.endpoint;
            }
        }

        async submit() {
            const tagId = await this.createTag(this.endpoint);
            if (tagId === "") return;
            const workerId = await this.createWorker(this.endpoint);
            if (workerId === "") return;
            const suc = this.pair(this.endpoint, tagId, workerId);
            if (suc) {
                this.message = `Created worker ${this.worker} with id ${workerId} and tag of mac address ${this.mac} with id ${tagId}`;
                this.error = "";
            } else {
                this.message = "";
                this.error = "failed to pair";
            }
        }

        async pair(endpoint: string, tagId: string, workerId: string): Promise<boolean> {
            const pair = endpoint + `/api/Tag/${tagId}/worker/${workerId}`;
            const done = await this.http.ping(pair, "POST", {});
            return done.ok;
        }


        async createWorker(endpoint: string): Promise<string> {
            const createWorker = endpoint + "/api/Worker";
            const second = await this.http.ping(createWorker, "POST", {
                name: this.worker,
                contactNumber: "string",
                company: "string",
                registrationDate: new Date(),
                trades: [
                    "worker"
                ],
                certifications: [
                    "string"
                ]
            });
            if (!second.ok) {
                this.error = "failed to create tags";
                this.message = "";
                return "";
            }
            const work = await second.json();
            return work.id;
        }


        async createTag(endpoint: string): Promise<string> {
            const createTag = endpoint + "/api/Tag";
            const first = await this.http.ping(createTag, "POST", {
                "macAddress": this.mac
            });
            if (!first.ok) {
                this.error = "failed to create tags";
                this.message = "";
                return "";
            }
            const tag = await first.json();
            return tag.id;
        }

        clear() {
            this.src = ''
        }

        async pull() {
            if (this.ans) {
                const workers = await this.GetWorkers();

                const allWorkers: { [s: string]: FullWorker } = {};

                for (let k in workers) {
                    if (workers.hasOwnProperty(k)) {
                        const w = workers[k];
                        const full = await this.GetWorker(w.id);
                        if (full != null) {
                            allWorkers[full.id] = full;
                        }
                    }
                }

                this.allWorkers = allWorkers;
                try {
                    this.ptimeout = this.timeout.ToInt()
                } catch {
                }

                console.log("Workers: ", this.allWorkers);
            }
            setTimeout(this.pull, this.ptimeout);
        }

        get Style() {
            return {
                width: this.width + "px",
                height: this.height + "px",
            }
        }

        async mounted() {
            this.pull();
        }

        async GetWorker(id: string): Promise<FullWorker | null> {
            const resp = await this.http.ping(this.endpoint + "/api/WorkerCoordinates?workerId=" + id, "GET", {});
            if (!resp.ok) {
                return null;
            }
            const obj = await resp.json();
            return {
                id: obj.flyweightWorkerResponse.id,
                name: obj.flyweightWorkerResponse.name,
                x: obj.x,
                y: obj.y,
            }
        }

        async GetWorkers(): Promise<IWorker[]> {
            const resp = await this.http.ping(this.endpoint + "/api/Worker", "GET", {});
            if (!resp.ok) {
                return [];
            }
            const a: IWorker[] = await resp.json();
            return a;
        }
    }
</script>
